/* Copyright 2009, Chris Glasier

# Release 1.0 - Basic configuration

#Release 1.01 - Revisions
#   Added sketchup.rb (thanks to Tomasz SCF)
#   Add new scene setup for new files
#   Rename layer

#Release 1.04

#   skp functions renamed according to DeviceNameAction (DNA!) - e.g. sceneLayersAdd

Release 1.05

Observer and global variable renamed

START control as no Sketchup.active_model when the Ruby scripts are first loaded. 

Code rewritten so that no window.location call is followed by any javascript statements.

Changes since: (with Jim Foltz)

added scene set() to start to stop rare "slidersTop[0] = undefined" - e.g. if resizing with only start in display
general tidy up of indentation.
Automatic focusing of scene and component reels after selection in SU display 




SUGGESTIONS FOR SCENE MANAGEMENT

Use cgScenes

left column to browse (1st click) and (2nd click) open scene and current aspect
middle column to open aspects for current scene
middle column layer menu to sort layers by abc or visibility and to add and name new layer
middle column components menu to show or hide all current scene components 
right column to browse (1st click) and (2nd click) hide/show properties to save,layers and components, and change views and styles.

Click Update to save scene properties. Update takes priority over Synch.

Click Synch to update after making changes or component selection in Sketchup display. 

Use Sketchup

context menu to add, delete, rename or describe a scene
layer window to rename or delete existing layer
layer window to select layer colors
shadows toolbar

If a scene is not showing what is expected double check properties to ensure everything required is saved and check layer and components status as these can contradict eackh other. If still not performing correctly email chriglasier@gmail.com

*/

panelWidth = 	230        	//suggested
panelHeight = 	345       	//suggested
cellHeight = 	 20         //reccommended standard
columns     = 	  3         // for this device functionality
stripeTop = 	  7         //rows from top


/////FIXED LISTS; LAYERS,COMPONENTS,STYLES FROM MODEL DATA
// genericName,givenName,visibility(font colour)

aspectArray = new Array()
aspectArray.push(new Array("Properties","Property","true"))
aspectArray.push(new Array("Layers","Layer","true"))
aspectArray.push(new Array("Components","Component","true"))
aspectArray.push(new Array("Styles","Style","true"))
aspectArray.push(new Array("Views","View","true"))

viewsArray = new Array()
viewsArray.push(new Array("View","Top","true"))
viewsArray.push(new Array("View","Bottom","true"))
viewsArray.push(new Array("View","Front","true"))
viewsArray.push(new Array("View","Back","true"))
viewsArray.push(new Array("View","Left","true"))
viewsArray.push(new Array("View","Right","true"))
viewsArray.push(new Array("View","Isometric","true"))
viewsArray.push(new Array("View","ZoomExtents","true"))
viewsArray.push(new Array("View","Perspective","true"))



//FOR FILES WITH NO SCENES



newScenes = new Array("3d","Ortho","Trade")



//TEMPORARY NAMESET INTEGRATION SOLUTION




function menu1Down(e){}
function menu2Down(e){}




/////FUNCTION CALL FROM HTML FILE

/*
sets the size, sets variables, makes confirmPanel into start button for Mac compatibility (http://forums.sketchucation.com/viewtopic.php?f=180&t=19932#p166378)*/



function start(){;
    sceneDialogSize();
	sceneSet();
    with(confirmPanel) {
        innerHTML = "START";
        with(style){
            left = cellWidth;
            top = stripeTop*cellHeight;
            width = cellWidth;
			}
		}
	}	




//SET DIALOG SIZE TO DEFAULT (POSITION STAYS AS LEFT FROM PREVIOUS SESSION)

function sceneDialogSize() {
    w = panelWidth+6
    h = panelHeight+30
    cellWidth = Math.floor(panelWidth/columns)
    rows = Math.floor(panelHeight/cellHeight)
    params = new Array(w,h)
    params = params.join(",")
    window.location = "skp:coreSet_size@"+ params 
	}
	

	
function sceneSet() {
    scenePanelNames()
	layerSort = "abc"
    componentSort = "none"
    sceneAspect = "Properties"
    sliderTops = new Array(0,0,0)
    //FOR MENUS ...
    commander = "Scenes"  }
	
	
	


function confirmDown(e){
	switch(confirmPanel.innerHTML){
		case "START": sceneStart();  break;
		case "UPDATE": window.location = "skp:sceneUpdate"; break;
		case "CONFIRM" : coll = document.getElementById("sc2").childNodes
			if(coll[0].firstChild.tagName == "INPUT"){
			//Capitalises first letter for sorting
				newName = document.getElementById("transferBox").value
				newName = newName.charAt(0).toUpperCase()+newName.substr(1).toLowerCase()
				params = new Array(newName)
				params = params.join(",")
				confirmPanel.innerHTML =  "UPDATE"
				confirmPanel.style.backgroundColor = "#ff0000"
				window.location = "skp:sceneLayersRename@"+params 
				} 
			break
		}  
	}
 
  
  
  
function sceneStart(){
	//TO FIND IF ANY SCENES EXIST
    window.location = "skp:sceneStart" 
    //ruby calls add or run function
   }  
   
   

 //ADD SCENES

var scenesAddNo = -1

function sceneScenesAdd(){
	scenesAddNo ++
	list = newScenes
	params = list[scenesAddNo]
	if(scenesAddNo < list.length) window.location = "skp:sceneScenesAdd@"+params
	//ruby recalls function
	else sceneScenesRun()  
	}






function sceneScenesRun(){
	sceneSet()
	sceneScenesSelected() 
	sceneSetDeviceMenu()
	/*
	Asks to set component device to make componentsArray;
	cannot run extract two lists from model with single funtion because of Mac compatibility ( 		http://forums.sketchucation.com/viewtopic.php?f=180&t=19932&st=0&sk=t&sd=a&start=15#p166500 )
	This has a backup in sceneComponentsSelected(ind) function
	*/
	menuList = "Click 'Component' in center to set list "
	sceneDeviceMenuList()
	deviceMenu.style.textAlign = "center"
	}


	/////RESIZING


function sceneResize(){
    panelWidth = document.body.clientWidth
    panelHeight = document.body.clientHeight
    cellWidth = Math.floor(panelWidth/columns)
    rows = Math.floor(panelHeight/cellHeight)
	sceneScenesSelected()    
	}


///// PANEL NAMES



function scenePanelNames() {
    copyPanel = document.getElementById("copy")
    namePanel = document.getElementById("name")
    devicePanel = document.getElementById("device")
    confirmPanel = document.getElementById("confirm")
    menuPanel1 = document.getElementById("menu1")
    menuPanel2 = document.getElementById("menu2")   }




///// CURRENT SCENE



function sceneScenesSelected() { 
	window.location = "skp:sceneScenesSelected"   
	}



/////SCENE ADJUST


function sceneScenesSelectedReturn(ind){
    sliderTops[0] = ind    
	//CLEARS EVERYTHING
    devicePanel.innerHTML = ""
	//REMAKES DEVICE PANELS 
    sceneSetDeviceHolder()
    sceneSetDeviceMenu()
    sceneStripe()
    sceneColumnSliders()
    scenePanelSizes()
	//REMAKES SCENES LIST + ASPECT LIST
    sceneScenesList()
	}
	
	
/////SLIDE TO COMPONENT NAME
	
var componentsArray = new Array()
	
	
function sceneComponentsSelected(ind){
//IN CASE ARRAY NOT SET AT START;
	if(componentsArray.length == 0){
		menuList = "First click 'Component' "
		sceneDeviceMenuList()
		deviceMenu.style.textAlign = "center" 
		}
	else{
		sceneComponentsSelectedRun(ind)
		}
	}

	
	
	
	function sceneComponentsSelectedRun(ind){
	//PUTS COMPONENT IN ASPECT REEL ON FOCUS LINE
	for(a=0; a<aspectArray.length; a++){
		if(aspectArray[a][1] == "Component") aind = a    
		}
    document.getElementById("sc1").style.top = (stripeTop-aind)*cellHeight 
	//RERUNS COMPONENT LIST
	childNos = componentsArray
	colNo = 2
	sceneRunChildren()
    coll = document.getElementById("sc2").childNodes
		for(a=0; a<coll.length; a++){
		splitId = coll[a].id.split(",")
			if(splitId[3] == ind)  sliderTops[2] = a 
		}
	//ADJUST SLIDER TOP TO FOCUS SELECTED COMPONENT	
    colNo = 2
    activeRow = sliderTops[2]
    sceneAdjustSlider()         
	}
	




/////DEVICE COMPONENT PANELS - NORMALLY OVERLAYS NAMESET



function sceneSetDeviceHolder(){
	obj = document.createElement("div")
	devicePanel.appendChild(obj)
	obj.id = "holder"
	deviceHolder = document.getElementById("holder")
	with(deviceHolder){
		className = "device"
			with(style){
			top = 0
			width = panelWidth
			height = panelHeight 
			}  
		}  
	}


function sceneSetDeviceMenu(){
	obj = document.createElement("div")
	devicePanel.appendChild(obj)
	obj.id = "dmenu"
	deviceMenu = document.getElementById("dmenu")
	with(deviceMenu){
		className = "deviceMenu"
		with(style){
			top=0
			width =panelWidth
			height = cellHeight  
			}  
		}  
	}


	
	

function sceneStripe(){
	obj = document.createElement("div")
	deviceHolder.appendChild(obj)
	with(obj){
		id  = "stripe"
		className = "stripe"
		with(style){
			left = 0
			top = stripeTop * cellHeight
			width = columns * cellWidth
			height = cellHeight  
			} 
		}  
	}


	
	
function sceneColumnSliders(){
	bLeft = 0
	for(a=0; a<columns; a++){
		sceneColumnSlider() 
		}  
	} 


	
	
function sceneColumnSlider(){
	obj = document.createElement("div")
	deviceHolder.appendChild(obj)
	with(obj){
		colNo = a
		id  = "sc"+ colNo 
		with(style){
			theTop = stripeTop-eval(sliderTops[a])
			top = theTop*cellHeight   
			}  
		}   
	}



//ADJUSTS HTML FILE DIVS



function scenePanelSizes(){
	with(namePanel){
		with(style){
			left    = 0
			top     = 2 * cellHeight  
			} 
		}

	with(devicePanel){
		with(style){
			left = 0
			top = 2 * cellHeight
			}
		}

	with(confirmPanel){
		with(style){
			left = panelWidth-cellWidth
			top = 0   
			width = cellWidth
			display = "none"
			}
		}


	with(menuPanel1){
		className = "device"
		with(style){
			left = 0
			top = 0 
			width = panelWidth
			height = cellHeight
			}  
		}

	with(menuPanel2){
	className = "device"
		with(style){
			left = 0
			top = cellHeight
			width = panelWidth
			height = cellHeight 
			}  
		} 

	with(copyPanel){
	innerHTML = "&copy;Chris Glasier 2008/9"
	className = "copy"
		with(style){
			left = 0
			top = 0
			width = panelWidth 
			}  
		} 

//SLIDER LEFTS

	bLeft = 0
	for(a=0; a<columns; a++){
		with(document.getElementById("sc"+a).style){
			left = bLeft
			width = bLeft * cellWidth   
			}
		bLeft = bLeft += cellWidth    
		}   
	}



/////SCENES




function sceneScenesList(){
    window.location = "skp:sceneScenesList"  }

function sceneScenesListRun(theArray){
    list = theArray.split(";")
    sceneArray = new Array()
    for(a=0; a<list.length; a++){
    couplet = list[a].split(",")
    thisName = couplet[0].split(" ")
    thisName = thisName.join("_")
    entry = new Array()
    entry[0] = "Scenes"
    entry[1] = thisName
    entry[2] = "true"
    sceneArray.push(entry)  } 
    childNos = sceneArray
    colNo = 0
    sceneRunChildren() 
    sceneAspectsList() 
    eval("scene"+sceneAspect+"List")() 
	}



/////ASPECTS (Devices better term?)


function sceneAspectsList(){
	childNos = aspectArray
	colNo = 1
	sceneRunChildren()  
	}



/////PROPERTIES

function scenePropertiesList(){
	window.location = "skp:scenePropertiesList" 
	}




function scenePropertiesListRun(theArray){
	list = theArray.split(";")
	propertiesArray = new Array()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		entry = new Array()
		entry[0] = "Property"
		entry[1] = thisName
		entry[2] = couplet[1]
		propertiesArray.push(entry)  } 
	scenePropertiesListChildren()  
	}

function scenePropertiesListChildren(){
	childNos = propertiesArray
	colNo = 2
	sceneRunChildren() 
	}




/////LAYERS



function sceneLayersList(){
	window.location = "skp:sceneLayersList"   
	}


function sceneLayersListRun(theArray){
	list = theArray.split(";")
	list.sort()
	//VISIBILITY SPLITTER
	if(layerSort == "vis"){
		visArray = new Array()
		invArray = new Array()
		for(a=0; a<list.length; a++){
			list[a]=list[a].split(",")
			if(list[a][1] == "true") visArray.push(list[a].join(","))
			else invArray.push(list[a].join(","))
			}
		list = visArray.concat(invArray)   
		}
	layersArray = new Array()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		//Layer0 not editable in cgScenes
		if(thisName == "Layer0") continue
		entry = new Array()
		entry[0] = "Layer"
		entry[1] = thisName
		entry[2] = couplet[1]
		entry[3] = couplet[2]
		layersArray.push(entry)  
		} 
	sceneLayersListChildren()
	}


function sceneLayersListChildren(){
	childNos = layersArray
	colNo = 2
	sceneRunChildren()  
	}



/////COMPONENTS



function sceneComponentsList(){
	window.location = "skp:sceneComponentsList"   
	}



function sceneComponentsListRun(theArray){
	list = theArray.split(";")
	componentsArray = new Array()
	for(a=0; a<list.length; a++){
		list[a] = list[a].charAt(0).toUpperCase()+list[a].substr(1).toLowerCase()  
		}
	list.sort()

	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		if(componentSort == "show") couplet[1] = "false" //all show
		if(componentSort == "hide") couplet[1] = "true"  // all hide
		//otherwise uses SU data
		entry = new Array()
		entry[0] = "Component"
		entry[1] = thisName
		couplet[1]=="false"? entry[2] = "true" : entry[2] = "false"
		entry[3] = couplet[2]
		componentsArray.push(entry)  
		} 
sceneComponentsListChildren()

   }



function sceneComponentsListChildren(){
	childNos = componentsArray
	colNo = 2
	sceneRunChildren()   
	}




/////STYLES



function sceneStylesList(){
	window.location = "skp:sceneStylesList"  
	}





function sceneStylesListRun(theArray){
	stylesArray = new Array()
	theArray = theArray.split("qq")
	list = theArray[0].split(";")
	activeStyle = theArray[1]
	list.sort()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		if(couplet[0] == activeStyle) activeRow = a
		sliderTops[2] = activeRow
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		entry = new Array()
		entry[0] = "Style"
		entry[1] = thisName
		entry[2] ="true"
		entry[3] = couplet[1]
		stylesArray.push(entry)  
		} 
sceneStylesListChildren()
	}




function sceneStylesListChildren(){
	childNos = stylesArray
	colNo = 2
	sceneRunChildren()
	colNo = 1  
	}



function sceneViewsList(){
	childNos = viewsArray
	colNo = 2  
	}




function sceneViewsListChildren(){
	sceneRunChildren()  
	}


//RUN OFF


function sceneRunChildren(){
	document.getElementById("sc"+ colNo).innerHTML = ""
	bTop = 0
	for(c=0; c<childNos.length; c++){
		genericName = childNos[c][0]
		givenName = childNos[c][1]
		//cind = SU ENTITY INDEX
		childNos[c][2] == "false"? theClass = "off" : theClass = "on"
		childNos[c][3] == undefined? cind = 0 : cind = childNos[c][3]
		obj = document.createElement("div")
		document.getElementById("sc"+ colNo).appendChild(obj)
		with(obj){
			id = new Array(genericName,colNo,c,cind)
			innerHTML = givenName
			title = id            //for testing
			className = theClass 
			with(style){
				left = 0
				top = bTop 
				width = cellWidth
				height = cellHeight   
				}   
			}
		bTop+= cellHeight    
		}   
}




//EVENTS IN COLUMNS



var counter = 0
var lastCell = undefined

function coreTarget(e){
	var targ;
	if (!e) {
		var e = window.event 
		}
	if (e.target){
		targ = e.target;  
		}
	else if (e.srcElement){
		targ = e.srcElement;  
		}
	thisCell = targ  
	}



function deviceDown(e){
	coreTarget()
	if(thisCell.id == "holder" ) return
	if(thisCell.id == "dmenu" ) return
	if(thisCell.tagName == "INPUT") return
	//DEVICE MENUS
	if(thisCell.parentNode.id == "dmenu"){
		try{
			deviceMenuDown() 
			}
		catch(e){
			}
		return 
		}
 //ONE CLICK TO NAVIGATE; SECOND CLICK ON SAME CELL TO ACTION
	thisCell == lastCell? counter = 1 : counter = 0
	lastCell = thisCell
	sceneCellId = thisCell.id.split(",")
	genericName = sceneCellId[0]
	commander = genericName
	colNo = sceneCellId[1]
	activeRow = sceneCellId[2]
	cind = sceneCellId[3]
	sceneAdjustSlider()
	eval("scene"+colNo+"Down")()    
	}



/////SLIDER


function sceneAdjustSlider(){
	slider = document.getElementById("sc"+ colNo)
	startTop = slider.style.top.slice(0,-2)
	cTop = activeRow-stripeTop
	finishTop = -cTop*cellHeight
	diff = startTop-finishTop
	/*
	The following varies the increment and therefore speed depending on distance to be travelled.
	It would be more machine like to ease in and ease out - anyone?
	*/
	if(diff > 0) diff = -diff
	diff = -diff
	lgth = 100
	increment = Math.floor(diff/lgth*10)
	//menuPanel2.innerHTML = diff+" "+lgth+" "+increment - for testing
	sceneSlideStop = setInterval(sceneSlide,5)   
	}




function sceneSlide(){
	theTop = slider.style.top.slice(0,-2)
	if(theTop == finishTop){
		clearInterval(sceneSlideStop)
		// ADJUSTS THE POSITION BECAUSE CURRENT STYLE IS KNOWN
		if(genericName == "Style"){
			colNo = 2
			sceneAdjustSlider()   
			}   
		}
	else{
		eval(startTop)-finishTop > 0? x = -1 :x = 1
		theTop = slider.style.top.slice(0,-2)
		theTop = eval(theTop)+x*increment
		slider.style.top = theTop+"px"    
		}   
	}



/////FIRST COLUMN


function scene0Down(){
	sliderTops[0] = activeRow
	if(counter == 1) sceneSceneOpen()
	else{
		document.getElementById("sc"+2).innerHTML =""
		menuList = "Again to confirm"
		sceneDeviceMenuList()
		deviceMenu.style.textAlign = "left"   
		}  
	}





function sceneSceneOpen(){
	//OPENS SCENE
	params = activeRow
	window.location = "skp:sceneSceneOpen@"+params  
	}





function sceneSceneOpenRun(){
	//CLEARS MENU
	menuList = ""
	sceneDeviceMenuList()     
	eval("scene"+sceneAspect+"List")()    
	}





//SECOND COLUMN



function scene1Down(){
	sliderTops[1] = activeRow
	document.getElementById("sc2").innerHTML = ""
	// TO STOP LISTS DISAPPEARING
	theTop = document.getElementById("sc2").style.top.slice(0,2)
	if(theTop < cellHeight) theTop = cellHeight
	document.getElementById("sc2").style.top = theTop + "px"
	sceneAspect = genericName
	menuList = eval("scene"+sceneAspect+"Menu")
	sceneDeviceMenuList()
	deviceMenu.style.textAlign = "center"
	eval("scene"+genericName+"List")()   
	}


//THIRD COLUMN

function scene2Down(){
	sliderTops[2]= activeRow
	menuList = ""
	sceneDeviceMenuList()  
	deviceMenu.style.textAlign = "right"
	eval("sceneTools"+genericName)()  
	}




//ACTIONS FROM EVENTS IN COLUMNS



function sceneToolsProperty(){
	if(counter==1) scenePropertyToggle()
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()   
		}  
	}


	
	
function sceneToolsLayer(){
	if(counter==1) sceneLayerToggle()
	else{
	//INPUT CELL FROM LAYERS ADD/RENAME
		if(thisCell.tagName =="INPUT") menuList = ""
		else {
			menuList = "Again to toggle"
			sceneDeviceMenuList()   
			}  
		}   
	}




function sceneToolsComponent(){
	if(counter==1) sceneComponentToggle()
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()
		//HIGHLIGHTS BOUNDING BOX
		window.location = "skp:sceneHiliteOn@"+cind  
		} 
	}




function sceneToolsView(){
	if(counter==1){
		sceneUpdater()
		word = thisCell.innerHTML
		window.location = "skp:sceneView"+word  
		}
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()   
		}  
	}




function sceneToolsStyle(){
	if(counter==1){
		sceneUpdater()
		window.location = "skp:sceneStyleUse@"+cind   
		}
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()  
		}   
	}




//MENUS AND ACTIONS

scenePropertiesMenu = "Properties to save"
sceneLayersMenu = "Abc,Visibility,Add"
sceneComponentsMenu = "Pending"

//For Release 2 series

sceneCollectionsMenu = "Will allow selection of collection names"
sceneGroupingsMenu = "Will allow selection of grouping names"

sceneComponentsMenu = "Show_all,Hide_all"
sceneViewsMenu = "Orthogonal views"
sceneStylesMenu = "Styles in model"



function sceneDeviceMenuList(){
	deviceMenu.innerHTML = ""
	list = menuList.split(",")
	for(a=0; a<list.length; a++){
		obj = document.createElement("a")
		deviceMenu.appendChild(obj)
		with(obj){
			innerHTML = list[a]
			className = "menu" 
			}  
		}  
	}




function deviceMenuDown(e){
	coreTarget()
	menuCell = thisCell
	menuName =  menuCell.innerHTML.split(" ").join("")
	menuPanel = deviceMenu
	try{
		eval("scene"+commander+menuName)()
		}
	catch(e){
		}  
	}



function sceneLayersAbc(){
	layerSort = "abc"
	sliderTops[2] = 0
	}


function sceneLayersVisibility(){
	layerSort = "vis"
	sliderTops[2] = 0
	}


function sceneLayersAdd(){
	sliderTops[2] = 0
	window.location = "skp:sceneLayersAdd"
	}



function sceneLayerRename(){
	newCell = document.getElementById("sc"+2).firstChild
	transferName = newCell.innerHTML
	newCell.innerHTML = ""
	obj = document.createElement("input")
	newCell.appendChild(obj)
	with(obj){
		id = "transferBox"
		value = transferName
		with(style){
			width =cellWidth
			height = cellHeight
			backgroundColor = "pink"   
			}   
		}
	confirmPanel.innerHTML = "CONFIRM"         
	}



//ONLY FOR NEW NAMES; OTHER RENAMING IN SU LAYER WINDOW



function sceneComponentsShow_all(){
	componentSort = "show"
	//RETURNS TO DEFAULT
	componentSort = "none" 
	//UPDATER
	sceneUpdater()
	params = "Show"
	//CHANGES SU DISPLAY
	window.location = "skp:sceneComponentsToggleAll@"+params   
	}




function sceneComponentsHide_all(){
	componentSort = "hide"
	params = "Hide"
	//RETURNS TO DEFAULT
	componentSort = "none" 
	//UPDATER
	sceneUpdater()
	//CHANGES SU DISPLAY
	window.location = "skp:sceneComponentsToggleAll@"+params  
	}



 
function scenePropertyToggle(){
    //CHANGES FONT COLOUR
    thisCell.className == "on"? cl = "off" : cl = "on";
    thisCell.className = cl;
    cl=="on"? sw = "off" : sw = "on";
    //CHANGES SU DISPLAY DIRECTLY - REQUIRES UPDATE TO SAVE
    sceneUpdater();
    //CHANGES SU DISPLAY
    var property = thisCell.innerHTML;
    var callback = "scenePropertyToggle@" + property +"," + sw;
    window.location = "skp:" + callback;
	}




function sceneLayerToggle(){
	thisCell.className == "on"? cl = "off" : cl = "on"
	thisCell.className = cl
	cl=="on"? sw = "off" : sw = "on"
	sceneUpdater()
	fileName = "sceneLayerToggle"+sw
	window.location = "skp:"+fileName+"@"+cind   }


	
	
function sceneComponentToggle(){
	thisCell.className == "off"? cl = "on" : cl = "off"
	thisCell.className = cl
	cl == "off"? sw = "on" : sw = "off"
	sceneUpdater()
	fileName = "sceneComponentToggle"+sw
	window.location = "skp:"+fileName+"@"+cind   }

	
	

//SCENE UPDATER

function sceneUpdater(){
	confirmPanel.innerHTML ="UPDATE" 
	confirmPanel.style.display = "block"
	confirmPanel.style.backgroundColor ="#ff0000"   }


